import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

LoadSettings();

--## fires out startup text with option settings overview ##--
-- Sets the title, author and version. --
local author = Plugins["WCFilter"]:GetAuthor()
local version = Plugins["WCFilter"]:GetVersion()
local hello = "\n\n<u><rgb=#DAA520>WCFilter v"..version..", "..WCFLangData.by..author..WCFLangData.loaded.." ...</rgb></u>"
-- Sets the colorcodes for options-output on start --
local col1 = "<rgb=#20A5DA>  "
local col2 = "<rgb=#BA4020>"
local col3 = "<rgb=#AAA5DA>"
local col4 = "<rgb=#DA4040>"
local col0 = "</rgb>"
local opton = col3..WCFLangData.active..col0
local optoff = col4..WCFLangData.inactive..col0
-- Config the texts for options-output --
if (settings.invert == true) then textinvert = opton; else textinvert = optoff; end
if (settings.sell == true) then textsell = opton; else textsell = optoff; end
if (settings.give == true) then textgive = opton; else textgive = optoff; end
if (settings.valar == true) then textvalar = opton; else textvalar = optoff; end
if (settings.buy == true) then textbuy = opton; else textbuy = optoff; end
if (settings.search == true) then textsearch = opton; else textsearch = optoff; end
if (settings.exchange == true) then textexchange = opton; else textexchange = optoff; end
if (settings.group == true) then textgroup = opton; else textgroup = optoff; end
if (settings.kinship == true) then textkinship = opton; else textkinship = optoff; end
if (settings.craft == true) then textcraft = opton; else textcraft = optoff; end
if (settings.chelp == true) then textchelp = opton; else textchelp = optoff; end
if (settings.mp == true) then textmp = opton; else textmp = optoff; end
if (settings.links == true) then textlinks = opton; else textlinks = optoff; end
if (settings.higb == true) then texthigb = opton; else texthigb = optoff; end
if (settings.exfilter == true) then textefstate = opton; else textefstate = optoff; end
if (settings.infilter == true) then textifstate = opton; else textifstate = optoff; end
if (settings.blstate == true) then textblstate = opton; else textblstate = optoff; end
if (settings.wlstate == true) then textwlstate = opton; else textwlstate = optoff; end
-- Sets the option settings overview --
hello = hello.."\n <u>"..col2..WCFLangData.invert..": "..col0..textinvert.."</u>";
hello = hello.."\n "..col1..WCFLangData.efstate..": "..col0..textefstate;
hello = hello.."\n "..col1..WCFLangData.ifstate..": "..col0..textifstate;
hello = hello.."\n "..col1..WCFLangData.pbllabel..": "..col0..textblstate;
hello = hello.."\n "..col1..WCFLangData.pwllabel..": "..col0..textwlstate;
hello = hello.."\n "..col1..WCFLangData.sell..": "..col0..textsell;
hello = hello.."\n "..col1..WCFLangData.give..": "..col0..textgive;
hello = hello.."\n "..col1..WCFLangData.valar..": "..col0..textvalar;
hello = hello.."\n "..col1..WCFLangData.buy..": "..col0..textbuy;
hello = hello.."\n "..col1..WCFLangData.search..": "..col0..textsearch;
hello = hello.."\n "..col1..WCFLangData.exchange..": "..col0..textexchange;
hello = hello.."\n "..col1..WCFLangData.group..": "..col0..textgroup;
hello = hello.."\n "..col1..WCFLangData.kinship..": "..col0..textkinship;
hello = hello.."\n "..col1..WCFLangData.craft..": "..col0..textcraft;
hello = hello.."\n "..col1..WCFLangData.chelp..": "..col0..textchelp;
hello = hello.."\n "..col1..WCFLangData.mp..": "..col0..textmp;
hello = hello.."\n "..col1..WCFLangData.links..": "..col0..textlinks;
hello = hello.."\n "..col1..WCFLangData.higb..": "..col0..texthigb;
-- Sets ay Hello to player
localPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
PlayerName = localPlayer:GetName();
hello = hello.."\n\n "..col3.."<b><i>"..WCFLangData.hello..PlayerName.."!</i></b>"..col0;
-- fire out startup-text
Turbine.Shell.WriteLine(hello);
Turbine.Shell.WriteLine("");

--## some window stuff and declare callbacks ##--
win = Turbine.UI.Window();
win:SetBackground("Burgus/WCFilter/lotro.tga");
win:SetVisible(true);
win:SetStretchMode(2);
win.nativeWidth, win.nativeHeight = win:GetSize();
win:SetVisible(false);
win:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
win:SetMouseVisible(false);
win:SetZOrder(2147483647);
win.backColor = Burgus.Utils.Color(1, 1, 1);
win.rotateAngle = 0;
win.hueAngle = 0;

player = Turbine.Gameplay.LocalPlayer:GetInstance();
AddCallback(player, "InCombatChanged", function(sender, args)
	win.inCombat = player:IsInCombat();
	if (win.inCombat) then
		win.x, win.y = Turbine.UI.Display:GetMousePosition();
		win:SetWantsUpdates(true);
	end
end);

AddCallback(optionsPanel, "SettingsChanged", function()
	SaveSettings("silent");
	if (not settings.cycleColors) then
		win:SetBackColor(win.backColor);
	end
	win:SetVisible(false);
	win.displayStartTime = nil;
	win.x, win.y = nil, nil;
	win:SetWantsUpdates(true);
end);

--## The chatHandler for filtering the chat and output ##--
-- function for userdefined pattern
function CheckPattern(args, ctext, pattern)
	if string.len(pattern) >= 2 then
		local spat = "[%s%a%w%%%c%\195\128%\195\132%\195\137%\195\150%\195\156%\195\159%\195\160%\195\161%\195\162%\195\163%\195\164%\195\165%\195\166%\195\167%\195\168%\195\169%\195\170%\195\171%\195\172%\195\173%\195\174%\195\175%\195\176%\195\177%\195\178%\195\179%\195\180%\195\181%\195\182%\195\183%\195\184%\195\185%\195\186%\195\187%\195\188]+;"
		for w in string.gmatch(pattern, spat) do
			w = string.sub(w,1,string.len(w)-1)
			if string.find(ctext,w) then return true; end
		end
	end
	return false;
end;

-- function ResultCheck() needed for the function invert, to shorten the code. --
function ResultCheck(args)
	if (settings.invert == true) then Turbine.Shell.WriteLine(args.Message); end;
end;

-- pattern are set by eg. "string.find(CMsg, "Pattern")", the pattern have to set in lowercase only. --	
function chatHandler(sender, args)
	if args.ChatType == Turbine.ChatType.World then
		-- init --
		local CMsg = string.lower(args.Message)
		-- bypass own messages
		local PlayerName = string.lower(PlayerName)
		if string.find(CMsg, PlayerName) then Turbine.Shell.WriteLine(args.Message); return; --Player
		elseif string.find(CMsg, "an welt",1,56) then Turbine.Shell.WriteLine(args.Message); return; --own Messages
		end
		-- examine sender from message
		local CMsg1 = string.find(CMsg, ":", 16)+1
		local CMsg2 = string.find(CMsg, ">", CMsg1)+1
		local CMsg3 = string.find(CMsg, "<", CMsg2)-1
		local CMSender = string.lower(string.sub(CMsg, CMsg2, CMsg3))
		-- Other bypasses
		if string.find(CMsg, "WCFilter") then Turbine.Shell.WriteLine(args.Message); return; --Plugin
		elseif string.find(CMSender, "^+") then Turbine.Shell.WriteLine(args.Message); return; --GMs
		end
		-- Whitelist --
		if (settings.wlstate == true) then
			if settings.whitelist then
				for w in string.gmatch(settings.whitelist, "%a+") do if string.find(w, CMSender) then Turbine.Shell.WriteLine(args.Message); return; end end
			end
		end
		-- Blacklist --
		if (settings.blstate == true) then
			if settings.blacklist then
				for w in string.gmatch(settings.blacklist, "%a+") do if string.find(w, CMSender) then return; end end
			end
		end

		-- Strip plain message
		local CMsg1 = string.find(CMsg,":",36)+3
		local CMsg2 = string.sub(CMsg, CMsg1)
		local CMsg = string.sub(CMsg2, 1, string.len(CMsg2)-2)

		-- Exclude-Filter
		if (settings.exfilter == true) then if CheckPattern(args, CMsg, settings.exfpattern) == true then return; end end
		-- Include-Filter
		if (settings.infilter == true) then if CheckPattern(args, CMsg, settings.infpattern) == true then Turbine.Shell.WriteLine(args.Message); return; end end
		-- Filterdefinition --
		if (settings.sell == true) then
			if CheckPattern(args, CMsg, WCFPatData.sell) == true then ResultCheck(args); return; end
		end
		if (settings.give == true) then
			if CheckPattern(args, CMsg, WCFPatData.give) == true then ResultCheck(args); return; end	
		end
		if (settings.valar == true) then
			if CheckPattern(args, CMsg, WCFPatData.valar) == true then ResultCheck(args); return; end
		end
		if (settings.buy == true) then
			if CheckPattern(args, CMsg, WCFPatData.buy) == true then ResultCheck(args); return; end
		end
		if (settings.search == true) then
			if CheckPattern(args, CMsg, WCFPatData.search) == true then ResultCheck(args); return; end
		end
		if (settings.exchange == true) then
			if CheckPattern(args, CMsg, WCFPatData.exchange) == true then ResultCheck(args); return; end
		end
		if (settings.group == true) then
			if string.find(CMsg, "+") then ResultCheck(args); return;
			elseif string.find(CMsg, "%d/") then ResultCheck(args); return;
			elseif CheckPattern(args, CMsg, WCFPatData.group) == true then ResultCheck(args); return;
			end
		end
		if (settings.kinship == true) then
			if CheckPattern(args, CMsg, WCFPatData.kinship) == true then ResultCheck(args); return; end
		end
		if (settings.craft == true) then
			if CheckPattern(args, CMsg, WCFPatData.craft) == true then ResultCheck(args); return; end
		end
		if (settings.chelp == true) then
			if CheckPattern(args, CMsg, WCFPatData.chelp) == true then ResultCheck(args); return; end
		end
		if (settings.mp == true) then
			if CheckPattern(args, CMsg, WCFPatData.mp) == true then ResultCheck(args); return; end
		end
		if (settings.links == true) then
			if CheckPattern(args, CMsg, WCFPatData.links) == true then ResultCheck(args); return; end
		end
		if (settings.hello == true) then
			if CheckPattern(args, CMsg, WCFPatData.higb) == true then ResultCheck(args); return; end
		end
		if (settings.invert == false) then Turbine.Shell.WriteLine(args.Message); end;
	end		
end																			

AddCallback(Turbine.Chat, "Received", chatHandler);
